<template>
  <div class="product-variants-price-content">
    <div v-if="regularPrice"
         class="product-insights-value">
      <SfPrice class="product-variants-price"
               :regular="formatPrice(regularPrice)"
               :special="formatPrice(specialPrice)"/>
    </div>
    <div v-else
         class="product-variants-value">
      {{ $t('n/a') }}
    </div>
  </div>
</template>

<script lang="ts">
import {ref, computed} from "@vue/composition-api";
import {SfPrice} from "@storefront-ui/vue";
import SwTierPrices from "@/components/SwTierPrices.vue"
import {
  getProductTierPrices,
  getProductCalculatedPrice,
  getProductCalculatedListingPrice,
  getProductPriceDiscount,
} from "@shopware-pwa/helpers";
import { usePriceFilter } from "../../../logic/composables/usePriceFilter";

export default {
  name: "VariantPrice",
  components: {
    SfPrice,
    SwTierPrices,
  },
  props: {
    variant: {
      type: [Object,Array,String],
      default: null,
    },
  },
  setup(props, {}) {
    const variant = ref(props.variant);
    const { formatPrice } = usePriceFilter();

    const tierPrices = computed(() =>
        getProductTierPrices(variant.value)
    )

    const specialPrice = computed(() =>
        tierPrices.value.length
            ? undefined
            : getProductPriceDiscount(variant.value) &&
            getProductCalculatedPrice(variant.value)
    )

    const regularPrice = computed(() =>
        (tierPrices.value.length &&
            tierPrices.value[0] &&
            tierPrices.value[0].unitPrice) ||
        getProductCalculatedListingPrice(variant.value)
    )

    return {
      tierPrices,
      specialPrice,
      regularPrice,
      formatPrice
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .product-variants-price-content {
    .product-variants-price {
      --price-regular-font-size: var(--font-size--sm);
      --price-regular-font-weight: 300;
      --price-regular-font-family: var(--font-family--primary);
    }
  }
</style>
